;FACE INVADERS


;Graphics.
Graphics 840,580,16,2

AppTitle "FACE INVADERS"

;Timer.
timer = CreateTimer(60)

;Load highscore.
If ReadFile("score.dat") = 0 Then
highscore = 0
Else
file_score = ReadFile("score.dat")
highscore = ReadInt(file_score)
CloseFile (file_score) 
EndIf

AutoMidHandle True

;Load images.
img_Smile = LoadImage("smile.png")
img_Alien = LoadImage("alien.png")
img_Bullet = LoadImage("bullet.png")
img_Bomb = LoadImage("bomb.png")
img_Power = LoadImage("power.png")
img_Superbomb = LoadImage("superbomb.png")
img_Ultrabomb = LoadImage("ultrabomb.png")
img_Goodbomb = LoadImage("goodbomb.png")
img_Supergoodbomb = LoadImage("supergoodbomb.png")
img_Ultragoodbomb = LoadImage("ultragoodbomb.png")

;Load sounds.
snd_Powerdisappearance = LoadSound("powerdisappearance.wav")
snd_Powerappearance = LoadSound("Powerappearance.wav") 
snd_Powercollect = LoadSound("Powercollect.wav")
snd_Gameover = LoadSound("Gameover.wav")
snd_Bulletsound = LoadSound("Bulletsound.wav")
snd_Loselife = LoadSound("Loselife.wav")
snd_Bombsound = LoadSound("Bombsound.wav")
snd_Aliendeath = LoadSound("Aliendeath.wav")
snd_Levelcomplete = LoadSound("Levelcomplete.wav")
snd_Bulletoff = LoadSound("Bulletoff.wav")

;Load background.
backdrop = LoadImage("background.png")

x= 420
y= 400

;Bullet.
Type bullet
Field x
Field y
End Type

;Bomb.
Type bomb
Field x
Field y
End Type

;Superbomb.
Type superbomb
Field x
Field y
End Type

;Ultrabomb.
Type ultrabomb
Field x
Field y
End Type

;Goodbomb.
Type goodbomb
Field x
Field y
End Type

;Supergoodbomb.
Type supergoodbomb
Field x
Field y
End Type

;Ultragoodbomb.
Type ultragoodbomb
Field x
Field y
End Type

;Alien.
Type alien
Field x
Field y
End Type

;Lives.
Lives = 3

;Level to start on
level = 0

;set number of aliens at start.
numaliens = 1

;Set alien speed.
aspeed = 1
amx = aspeed
chdir = False

;Reset score.
score = 0

;Beginning command.

Text 425,130,"FACE INVADERS!",1,1

Text 425,160,"Created by Billy Bob.",1,1

Text 425,180,"Made using Blitz 2D.",1,1

Text 425,280,"Press Backspace to turn sound on and off.",1,1

Text 425,320,"Press Enter to begin.",1,1

;Buffers.

Repeat Until KeyHit(28) Or KeyHit(156)

SetBuffer BackBuffer()

;Flush the commands waiting.

FlushKeys

;Power.

image_x=Rnd(0,843+ImageWidth (img_power))
image_y=Rnd(0,585+ImageHeight(img_power))
picture_timer=MilliSecs()
SeedRnd(picture_timer)

moo=MilliSecs()
SeedRnd(moo)

While Not level = -1

If numaliens = 0 Then
level = level + 1
If mogulum = 1 Then If sound = 0 Then PlaySound(snd_levelcomplete)
mogulum = 1

;Alien number.
For z = 1 To jegg
For w = 1 To joggo
a.alien = New alien
a\x = 100 + 50*z
a\y = -80 + 120*w
Next
Next
EndIf

;Background.

TileBlock backdrop

;More power.

If oboe = 0 Then speed = 6
oboe = 1

boon = 6000
If level = 15 Then boon = boon - 100
If level = 16 Then boon = boon - 100
If level = 17 Then boon = boon - 100
If level = 18 Then boon = boon - 200
If level = 19 Then boon = boon - 200
If level = 20 Then boon = boon - 300

If (picture_timer + boon) <=MilliSecs()
If mode=0 Then
If sound = 0 Then PlaySound (snd_powerappearance)
image_x=Rnd(0,843-ImageWidth (img_power))
image_y=Rnd(0,585-ImageHeight(img_power))
mode=1
picture_timer=MilliSecs()
EndIf
EndIf

If (picture_timer + 30000) <=MilliSecs()
If mode=1 Then
If sound = 0 Then PlaySound (snd_powerdisappearance)
mode=0
picture_timer=MilliSecs()
EndIf
EndIf

If mode=0 Then 
   DrawImage(img_power, image_x, image_y)
   
   ;Collision with "Power".
   If ImagesCollide (img_smile,x,y,0,img_power,image_x,image_y,0) Then
      If sound = 0 Then PlaySound (snd_powercollect)
      image_x=Rnd(0,843-ImageWidth (img_power))
      image_y=Rnd(0,585-ImageHeight(img_power))
      mode=1
      oboe = 1
      speed = speed + 3
      moo=MilliSecs()
      
   EndIf

EndIf

If oboe = 1 Then
If (moo + 15000) <=MilliSecs() Then
speed = 6
EndIf
EndIf

DrawImage img_smile,x,y

;Keys.
If KeyDown(200) Then y = y - speed
If KeyDown(208) Then y = y + speed
If KeyDown(203) Then x = x - speed
If KeyDown(205) Then x = x + speed
;Limit player movement.
tiw = ImageWidth(img_smile) / 2
If x < tiw Then x = tiw
If x >= 843 - tiw Then x = 843 - tiw + 1
If y < tiw Then y = tiw
If y >= 585 - tiw Then y = 585 - tiw + 1
If KeyHit(1) Then lives = 0
If KeyHit(57) Then

;About bullets.
If sound = 0 Then PlaySound (snd_Bulletsound)
b.bullet = New bullet
b\x = x
b\y = y - 1
EndIf

;More about bullets.
For b.bullet = Each bullet
b\y = b\y - 5
DrawImage img_bullet,b\x,b\y
If b\y < - 5 Then
Delete b
score = score - 1
If sound = 0 Then PlaySound(snd_bulletoff)
EndIf
Next

;Sound options.
If sound = 2 Then
FlushKeys
sound = 1
EndIf
If KeyHit(14) Then
If sound = 0 Then sound = 2 
If sound = 1 Then sound = 0
EndIf

;More alien number.
joggo = 1
If level > 3 Then joggo = joggo + 1
jegg = 7
If level > 0 Then jegg = jegg + 1
If level > 8 Then jegg = jegg + 1

;Extra alien movement.
If chdir = True Then
amx = -amx
EndIf
chdir = False

numaliens = 0
;Alien movement.
For a.alien = Each alien
a\x = a\x + amx * level
;Count aliens.
numaliens = numaliens - 2
;Main alien movement.
a\x = a\x + amx
If a\x > 800 Then chdir = True
If a\x < 40 Then chdir = True

;Aliens drop.
smug = 375
smugging = 1000
smugged = 2000
If level = 2 Then
smug = smug - 10
smugging = smugging - 500
smugged = smugged - 100 
EndIf
If level = 3 Then
smug = smug - 10
smugged = smugged - 200 
EndIf
If level = 4 Then
smug = smug - 10
smugged = smugged - 100 
EndIf
If level = 5 Then
smug = smug - 35
smugged = smugged - 400
EndIf
If level = 6 Then
smug = smug - 10
smugged = smugged - 100
EndIf
If level = 7 Then
smug = smug - 10
smugged = smugged - 100 
EndIf
If level = 8 Then
smug = smug - 10
smugged = smugged - 100
EndIf
If level = 9 Then
smug = smug - 10
smugged = smugged - 100
EndIf
If level = 10 Then
smug = smug - 60
smugged = smugged - 200
EndIf
If level = 11 Then
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 12 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 13 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 14 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 15 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 16 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 17 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 18 Then 
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 19 Then
smug = smug - 5
smugged = smugged - 5
smugging = smugging - 5
EndIf
If level = 20 Then 
smug = smug - 5
smugged = smugged - 30
smugging = smugging - 5
EndIf

If Rand(smug) = 1 Then
If sound = 0 Then PlaySound(snd_Bombsound)
bombs.bomb = New bomb
bombs\x = a\x
Bombs\y = a\y
EndIf

If Rand(smugging) = 2 Then
If sound = 0 Then PlaySound(snd_Bombsound)
sbomb.superbomb = New superbomb
sbomb\x = a\x
sbomb\y = a\y
EndIf

If Rand(smugged) = 3 Then
If sound = 0 Then PlaySound(snd_Bombsound)
ubomb.ultrabomb = New ultrabomb
ubomb\x = a\x
ubomb\y = a\y
EndIf

If Rand(15000) = 4 Then
If sound = 0 Then PlaySound(snd_Bombsound)
gbomb.goodbomb = New goodbomb
gbomb\x = a\x
gbomb\y = a\y
EndIf

If Rand(15000) = 5 Then
If sound = 0 Then PlaySound(snd_Bombsound)
sgbomb.supergoodbomb = New supergoodbomb
sgbomb\x = a\x
sgbomb\y = a\y
EndIf

If Rand(15000) = 6 Then
If sound = 0 Then PlaySound(snd_Bombsound)
ugbomb.ultragoodbomb = New ultragoodbomb
ugbomb\x = a\x
ugbomb\y = a\y
EndIf

;Images collide "bullet" with "alien".
DrawImage img_alien,a\x,a\y
For b.bullet = Each bullet

If ImagesCollide (img_bullet,b\x,b\y,0,img_alien,a\x,a\y,0) Then
If sound = 0 Then PlaySound (snd_Aliendeath)
Delete a
Delete b
score = score + 1
If score > highscore Then highscore = score
Exit
EndIf
Next
Next

;About bombs.
For bombs.bomb = Each bomb
bombs\y = bombs\y + 4
DrawImage img_bomb,bombs\x,bombs\y
If bombs\y > 700 Then Delete bombs

;Images colide "bomb" with "smile".
If ImagesCollide (img_bullet,bombs\x,bombs\y,0,img_smile,x,y,0)
If sound = 0 Then PlaySound(snd_Loselife)
Delete bombs
lives = lives - 1
ElseIf bombs\y > 697 Then
Delete bombs
EndIf

Next

For sbomb.superbomb = Each superbomb
sbomb\y = sbomb\y + 5
DrawImage img_superbomb,sbomb\x,sbomb\y
If sbomb\y > 700 Then Delete sbomb

If ImagesCollide (img_bullet,sbomb\x,sbomb\y,0,img_smile,x,y,0)
If sound = 0 Then PlaySound(snd_Loselife)
Delete sbomb
lives = lives - 1
ElseIf sbomb\y > 697 Then
Delete sbomb
EndIf

Next

For ubomb.ultrabomb = Each ultrabomb
ubomb\y = ubomb\y + 6
DrawImage img_ultrabomb,ubomb\x,ubomb\y
If ubomb\y > 700 Then Delete ubomb

If ImagesCollide (img_bullet,ubomb\x,ubomb\y,0,img_smile,x,y,0)
If sound = 0 Then PlaySound(snd_Loselife)
Delete ubomb
lives = lives - 1
ElseIf ubomb\y > 697 Then
Delete ubomb
EndIf

Next

For gbomb.goodbomb = Each goodbomb
gbomb\y = gbomb\y + 4
DrawImage img_goodbomb,gbomb\x,gbomb\y
If gbomb\y > 700 Then Delete gbomb

If ImagesCollide (img_bullet,gbomb\x,gbomb\y,0,img_smile,x,y,0)
If sound = 0 Then PlaySound(snd_Loselife)
Delete gbomb
lives = lives + 1
ElseIf gbomb\y > 697 Then
Delete gbomb
EndIf

Next

For sgbomb.supergoodbomb = Each supergoodbomb
sgbomb\y = sgbomb\y + 5
DrawImage img_supergoodbomb,sgbomb\x,sgbomb\y
If sgbomb\y > 700 Then Delete sgbomb

If ImagesCollide (img_bullet,sgbomb\x,sgbomb\y,0,img_smile,x,y,0)
If sound = 0 Then PlaySound(snd_Loselife)
Delete sgbomb
lives = lives + 1
ElseIf sgbomb\y > 697 Then
Delete sgbomb
EndIf

Next

For ugbomb.ultragoodbomb = Each ultragoodbomb
ugbomb\y = ugbomb\y + 6
DrawImage img_ultragoodbomb,ugbomb\x,ugbomb\y
If ugbomb\y > 700 Then Delete ugbomb

If ImagesCollide (img_bullet,ugbomb\x,ugbomb\y,0,img_smile,x,y,0)
If sound = 0 Then PlaySound(snd_Loselife)
Delete ugbomb
lives = lives + 1
ElseIf ugbomb\y > 697 Then
Delete ugbomb
EndIf

Next

;What happens when less lives.
If lives < 1 Then

;Save highscore.
file_score = WriteFile("score.dat")
WriteInt(file_score,highscore)
CloseFile file_score
If sound = 0 Then PlaySound(snd_gameover)
Text 425,255,"GAME OVER!",1,1
oink=MilliSecs()
SeedRnd(oink)
.Gameover
If KeyHit(1) Then End
If (oink + 4000) <=MilliSecs() Then End
Flip
Goto Gameover
EndIf

;Lives.
Text 50,560,"LIVES: " + lives

;Draw score.
Text 700,560,"SCORE: " + score

;Draw highscpre.
Text 570,560,"HIGHSCORE: " + highscore,1,1

;Draw level number.
Text 270,560,"LEVEL: " + level,1,1

;Draw speed number.
Text 420,560,"SPEED: " + speed Shr 2,1,1

WaitTimer (timer)

;Flip screen monitor.
Flip

Wend                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                            